"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Component;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _innerComponent = _interopRequireDefault(require("./inner-component"));

var _compiler = _interopRequireDefault(require("mson/lib/compiler"));

var _useComponent2 = _interopRequireDefault(require("./use-component"));

var _styles = require("@material-ui/core/styles");

var _excluded = ["component", "definition"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var getOrZero = function getOrZero(value) {
  return value ? value : 0;
};

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    root: function root(props) {
      var marginTop = props.marginTop,
          marginRight = props.marginRight,
          marginBottom = props.marginBottom,
          marginLeft = props.marginLeft;
      return {
        marginTop: theme.spacing(getOrZero(marginTop)),
        marginRight: theme.spacing(getOrZero(marginRight)),
        marginBottom: theme.spacing(getOrZero(marginBottom)),
        marginLeft: theme.spacing(getOrZero(marginLeft))
      };
    }
  };
});

function Component(props) {
  var component = props.component,
      definition = props.definition,
      childProps = (0, _objectWithoutProperties2.default)(props, _excluded);

  var _useState = (0, _react.useState)(null),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      compiledComponent = _useState2[0],
      setCompiledComponent = _useState2[1];

  var _useComponent = (0, _useComponent2.default)(component, ['hidden', 'styles']),
      hidden = _useComponent.hidden,
      styles = _useComponent.styles;

  var styleProps = styles ? styles.get() : {};
  var classes = useStyles(styleProps); // Should we use the component generated from the definition?

  var comp = component ? component : compiledComponent; // Compile the component when the definition changes

  (0, _react.useEffect)(function () {
    if (definition) {
      setCompiledComponent(_compiler.default.newComponent(definition));
    }
  }, [definition]);
  (0, _react.useEffect)(function () {
    return function () {
      // Unmount. Did we use a definition to define a component in the state?
      if (comp) {
        // Fire the unmount before we destroy the component so that the event is not lost
        comp.emitChange('unmount'); // We don't want to destroy the component as this could remove listeners that were not
        // created in the React layer. For example, a form listens to all its fields and destroying
        // the form will cause it to stop listening to its fields. Instead, the React layer should
        // only remove listeners that it creates.
        //
        // comp.destroy();
      }
    };
  }, [comp]); // Note: the component can be falsy, e.g. it has not yet been defined

  if (comp && hidden) {
    return null;
  } else {
    // As a slight optimization, only display a wrapping tag if styles is truthy
    var innerComponent = /*#__PURE__*/_react.default.createElement(_innerComponent.default, (0, _extends2.default)({
      component: comp
    }, childProps));

    if (styles) {
      // Use a div so that we have a block-level element that supports vertical margins
      return /*#__PURE__*/_react.default.createElement("div", {
        className: classes.root
      }, innerComponent);
    } else {
      return innerComponent;
    }
  }
}