"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Tabs;

var _react = _interopRequireDefault(require("react"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Tabs = _interopRequireDefault(require("@material-ui/core/Tabs"));

var _Tab = _interopRequireDefault(require("@material-ui/core/Tab"));

var _icon = _interopRequireDefault(require("./icon"));

var _useComponent2 = _interopRequireDefault(require("./use-component"));

function Tabs(props) {
  var component = props.component;

  var _useComponent = (0, _useComponent2.default)(component, ['items', 'value']),
      items = _useComponent.items,
      value = _useComponent.value;

  function handleChange(event, value) {
    component.set({
      value: value
    });
    var itemName = items[value].name;
    component.emitChange(itemName);
  } // FUTURE: option to make this fixed under the main app bar?


  return /*#__PURE__*/_react.default.createElement(_AppBar.default, {
    position: "static",
    color: "default",
    elevation: 1 // tone down the elevation>

  }, /*#__PURE__*/_react.default.createElement(_Tabs.default, {
    value: value,
    onChange: handleChange,
    indicatorColor: "primary",
    textColor: "primary",
    scrollButtons: "auto",
    variant: "fullWidth"
  }, items && items.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement(_Tab.default, {
      label: item.label,
      icon: /*#__PURE__*/_react.default.createElement(_icon.default, {
        icon: item.icon
      }),
      key: index
    });
  })));
}