"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useComponent;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function useComponent(component, watchProps) {
  var _useState = (0, _react.useState)({}),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      props = _useState2[0],
      setProps = _useState2[1]; // We need useRef so that we can reference watchProps in the useEffect below


  var watchedProps = (0, _react.useRef)(watchProps).current;
  (0, _react.useEffect)(function () {
    // The component can be created at any time, e.g. when the definition is set. Therefore, we need
    // to handle a missing component until the component is present.
    var hasComponent = function hasComponent() {
      return !!component;
    };

    function handleFieldChange(name, value) {
      if (watchedProps.indexOf(name) !== -1) {
        setProps(function (prevProps) {
          return _objectSpread(_objectSpread({}, prevProps), {}, (0, _defineProperty2.default)({}, name, value));
        });
      }
    }

    function addListener() {
      if (hasComponent()) {
        component.on('$change', handleFieldChange); // Initialize the props using the component's values

        setProps(component.get(watchedProps));
      }
    }

    function removeListener() {
      if (hasComponent()) {
        component.removeListener('$change', handleFieldChange);
      }
    }

    addListener();
    return function () {
      return removeListener();
    };
  }, [component, watchedProps]); // Only rerun if component changes

  return props;
}